function featureRect = calcCnnFeatureRect(occBigRect, winRect, type)
% 'type' can be 'normalTrain', 'occTrain', 'normalDetect' or 'occDetect'

smallRect = changeRectPadding(winRect, 'winRect', 'smallRect');
switch type
    case 'normalTrain'
%         up = min(winRect(1), smallRect(1));
%         down = max(winRect(1) + winRect(3), smallRect(1) + smallRect(3)) - 1;
%         left = min(winRect(2), smallRect(2));
%         right = max(winRect(2) + winRect(4), smallRect(2) + smallRect(4)) - 1;
%         featureRect.rect = [up, left, down - up + 1, right - left + 1];
        featureRect.rect = winRect;
    case 'occTrain'
        up = min([occBigRect(1), winRect(1), smallRect(1)]);
        down = max([occBigRect(1) + occBigRect(3), winRect(1) + winRect(3), smallRect(1) + smallRect(3)]) - 1;
        left = min([occBigRect(2), winRect(2), smallRect(2)]);
        right = max([occBigRect(2) + occBigRect(4), winRect(2) + winRect(4), smallRect(2) + smallRect(4)]) - 1;
        featureRect.rect = [up, left, down - up + 1, right - left + 1];
    case 'normalDetect'
%         up = winRect(1) - floor(smallSize(1) / 2);
%         down = winRect(1) + winRect(3) - 1 + floor(smallSize(1) / 2);
%         left = winRect(2) - floor(smallSize(2) / 2);
%         right = winRect(2) + winRect(4) - 1 + floor(smallSize(2) / 2);
%         featureRect.rect = [up, left, down - up + 1, right - left + 1];
        featureRect.rect = winRect;
    case 'occDetect'
        up = winRect(1) - floor(smallRect(3) / 2) - floor(occBigRect(3) / 2);
        down = winRect(1) + winRect(3) - 1 + floor(smallRect(3) / 2) + floor(occBigRect(3) / 2);
        left = winRect(2) - floor(smallRect(4) / 2) - floor(occBigRect(4) / 2);
        right = winRect(2) + winRect(4) - 1 + floor(smallRect(4) / 2) + floor(occBigRect(4) / 2);
        featureRect.rect = [up, left, down - up + 1, right - left + 1];
    otherwise
        error('Unknown "type" in calcCnnFeatureRect.m');
end
featureRect.padding = featureRect.rect(3:4) ./ winRect(3:4);
featureRect.type = type;

end