function k = calcK(x1, x2, kernelType, sigma)
global enableGPU
if nargin == 3 && strcmp(kernelType, 'gaussian')
    error('sigma of kernel is undefined.');
end
% if enableGPU
%     x1 = gpuArray(x1);
%     x2 = gpuArray(x2);
% end
switch kernelType
    case 'gaussian'
        if isempty(sigma)
            sigma = 0.6;
        end
        c = ifft2(sum(fft2(x1) .* conj(fft2(x2)), 3));
        d = x1(:)' * x1(:) + x2(:)' * x2(:) - 2 * c;
        k = exp(-1 / (sigma ^ 2) * abs(d) / numel(d));
    case 'linear'
        k = real(ifft2(sum(fft2(x1) .* conj(fft2(x2)), 3) / numel(x1)));
    otherwise
        error('Unknown kernel type. Must be "gaussian" or "linear"');
end
% if enableGPU
%     k = gather(k);
% end
end