function [frameOverlap, overlapPrec, meanOverlap] = calcOverlap(result, groundtruth)
frameNum = size(groundtruth, 1);
frameOverlap = zeros(frameNum, 1);

for i = 1 : frameNum
    resultRect = result(i,:);
    if (resultRect(1) < 0)
        resultRect(3) = resultRect(3) + resultRect(1);
        resultRect(1) = 0;
    end
    if (resultRect(2) < 0)
        resultRect(4) = resultRect(4) + resultRect(2);
        resultRect(2) = 0;
    end
    frameOverlap(i) = rectOverlap(groundtruth(i,:), resultRect);
end

overlapPrec = zeros(100, 1);
index = 1;
for threshold = 0.01:0.01:1
    temp = frameOverlap >= threshold;
    overlapPrec(index) = sum(temp) / frameNum;
    index = index + 1;
end
meanOverlap = mean(frameOverlap);
end