function dstRect = changeRectPadding(srcRect, srcRectType, dstRectType)
global paddingParams

if nargin == 2
    dstRect = changePadding(srcRect, srcRectType(1), srcRectType(2));
else
    switch srcRectType
        case 'originalRect'
            srcPadding = [1, 1];
        case 'winRect'
            srcPadding = paddingParams.winRectPadding;
        case 'smallRect'
            srcPadding = paddingParams.smallPadding;
        case 'occBigRect'
            srcPadding = paddingParams.occBigPadding;
        case 'scaleRect'
            srcPadding = paddingParams.scaleRectPadding;
        otherwise
            error('Unknown "srcRectType"');
    end

    switch dstRectType
        case 'originalRect'
            dstPadding = [1, 1];
        case 'winRect'
            dstPadding = paddingParams.winRectPadding;
        case 'smallRect'
            dstPadding = paddingParams.smallPadding;
        case 'occBigRect'
            dstPadding = paddingParams.occBigPadding;
        case 'scaleRect'
            dstPadding = paddingParams.scaleRectPadding;
        otherwise
            error('Unknown "dstRectType"');
    end

    r = dstPadding ./ srcPadding;
    dstRect = changePadding(srcRect, r(1), r(2));
end

end

function dstRect = changePadding(srcRect, rr, cr)
rd = srcRect(1:2) + srcRect(3:4) - 1;
center = (srcRect(1:2) + rd) / 2;
u = round(center(1) + rr * (srcRect(1) - center(1)));
d = round(center(1) + rr * (rd(1) - center(1)));
l = round(center(2) + cr * (srcRect(2) - center(2)));
r = round(center(2) + cr * (rd(2) - center(2)));
dstRect = [u, l, d - u + 1, r - l + 1];
end