function featurePatchs = extractPatchFromCnnFeature(cnnFeature, layers, scrRect, dstSize, cellSize, validAreaRatio, winType, winParam)
% 'winParam' means r for tukey and alpha for gausswin

featurePatchs = cell(length(layers), 1);

for ii = 1 : length(layers)

    layer = layers(ii);
    channels = cnnFeature(layer).channels;

    rect = [scrRect(1:2) - cnnFeature(layer).rect(1:2) + 1, scrRect(3:4)];
    rows = rect(1) : (rect(1) + rect(3) - 1);
    cols = rect(2) : (rect(2) + rect(4) - 1);
    temp = channels(rows, cols, :);
    im = cnnFeature(layer).im(rows, cols, :);

    dSize = floor(dstSize / cellSize);
    temp = imResample(temp, dSize);
    dstSizeImg = imResample(im, dSize);

    featurePatchs{ii}.feat = windowing(temp, validAreaRatio, winType, winParam);
    featurePatchs{ii}.im = uint8(windowing(double(dstSizeImg), validAreaRatio, winType, winParam));

end

end