function scalePatchs = extractScaleFeature(img, featureType, scrRect, dstSize, cellSize, hogOrientations, validAreaRatio, winType, winParam)

imgSize = size(img);
rows = scrRect(1) : (scrRect(1) + scrRect(3) - 1);
cols = scrRect(2) : (scrRect(2) + scrRect(4) - 1);
rows(rows < 1) = 1;  cols(cols < 1) = 1;
rows(rows > imgSize(1)) = imgSize(1);
cols(cols > imgSize(2)) = imgSize(2);
rawPatch = img(rows, cols, :);
rawPatch = imResample(rawPatch, dstSize(1:2));
im = uint8(windowing(double(rawPatch), validAreaRatio, winType, winParam));

if strcmp(featureType, 'hog') || strcmp(featureType, 'both')
    if size(rawPatch, 3) > 1
        patch = rgb2gray(rawPatch);
    end
    hog = double(fhog(single(patch) / 255, cellSize, hogOrientations));
    hog(:,:,end) = [];
    hog = windowing(hog, validAreaRatio, winType, winParam);
    s1 = struct('feat', hog, 'im', im);
end

if strcmp(featureType, 'rgb') || strcmp(featureType, 'both')
    patch = double(imResample(rawPatch, floor(dstSize / cellSize))) / 255;
    rgb = patch - mean(patch(:));
    rgb = windowing(rgb, validAreaRatio, winType, winParam);
    s2 = struct('feat', rgb, 'im', im);
end

switch featureType
    case 'hog'
        scalePatchs = {s1};
    case 'rgb'
        scalePatchs = {s2};
    case 'both'
        scalePatchs = {s1, s2};
    otherwise
        error('Unknown featureType in extractScaleFeature');
end

end