function  net = finetune_Net_first(img, region, net,varargin)
% MDNET_RUN
% Main interface for MDNet tracker
%
% INPUT:
%   images  - 1xN cell of the paths to image sequences
%   region  - 1x4 vector of the initial bounding box [left,top,width,height]
%   net     - The path to a trained MDNet
%   display - True for displying the tracking result
%
% OUTPUT:
%   result - Nx4 matrix of the tracking result Nx[left,top,width,height]
%
% Hyeonseob Nam, 2015
% 

% if(nargin<4), display = true; end
 
%% Initialization
fprintf('Initialization...\n');

% nFrames = length(images);


if(size(img,3)==1), img = cat(3,img,img,img); end
targetLoc = region;
 

 [net, opts] = mdnet_init2(img, net);
% net.layers={net_conv.layers{:},net_fc.layers{1:end}};
 
%% Extract training examples
fprintf('  extract features...\n');

% draw positive/negative samples
pos_examples = gen_samples('gaussian', targetLoc, opts.nPos_init*2, opts, 0.1, 5);
r = overlap_ratio(pos_examples,targetLoc);
pos_examples = pos_examples(r>opts.posThr_init,:);
pos_examples = pos_examples(randsample(end,min(opts.nPos_init,end)),:);


neg_examples = [gen_samples('uniform', targetLoc, opts.nNeg_init, opts, 1, 10);...
    gen_samples('whole', targetLoc, opts.nNeg_init, opts)];
r = overlap_ratio(neg_examples,targetLoc);
neg_examples = neg_examples(r<opts.negThr_init,:);
neg_examples = neg_examples(randsample(end,min(opts.nNeg_init,end)),:);

posdata = mdnet_exact_images( img, pos_examples, opts);%,0,'/home/xzhao/matConvNet/MDNet-masterForMKCF/pos.h5','/pos');
negdata = mdnet_exact_images( img, neg_examples, opts);%,0,'/home/xzhao/matConvNet/MDNet-masterForMKCF/neg.h5','/neg');


% examples = [pos_examples; neg_examples];
% pos_idx = 1:size(pos_examples,1);
% neg_idx = (1:size(neg_examples,1)) + size(pos_examples,1);

% extract conv3 features
% feat_conv = mdnet_features_convX(net_conv, img, examples, opts);
% pos_data = feat_conv(:,:,:,pos_idx);
% neg_data = feat_conv(:,:,:,neg_idx);


%% Learning CNN
fprintf('  training cnn...\n');
% net_fc = mdnet_finetune_hnm(net_fc,pos_data,neg_data,opts,...
%     'maxiter',opts.maxiter_init,'learningRate',opts.learningRate_init);
 net = finetune_first_hmm(net,posdata,negdata,opts,'maxiter',opts.maxiter_init,'learningRate',opts.learningRate_init);

