function init_paddingParams(paddingSets, targetSize, imgSize)
global paddingParams

% winRect
if(targetSize(1)/targetSize(2) > 2)
    % For objects with large height, we restrict the search window with padding.height
    winRectSize = floor(targetSize .* [paddingSets.padding.height, paddingSets.padding.generic]);    
elseif(prod(targetSize)/prod(imgSize(1:2)) > 0.05)
    % For objects with large height and width and accounting for at least 10 percent of the whole image,
    % we only search 2x height and width
    winRectSize=floor(targetSize * paddingSets.padding.large);
else
    %otherwise, we use the padding configuration
    winRectSize = floor(targetSize * paddingSets.padding.generic);
end
paddingParams.winRectPadding = winRectSize ./ targetSize;

% smallRect
switch paddingSets.smallPaddingType
    case 'prop'
        paddingParams.smallPadding = repmat(paddingSets.smallPaddingValue, [1, 2]);
    otherwise
        error('Unknown "paddingSets.smallPaddingType". Must be "prop".')
end

% occBigRect
switch paddingSets.occPaddingType
    case 'prop'
        paddingParams.occBigPadding = repmat(paddingSets.occPaddingValue, [1, 2]);
    case 'square'
        occSize = repmat(floor(sqrt(prod(targetSize * paddingSets.occPaddingValue))), 1, 2);
        paddingParams.occBigPadding = occSize ./ targetSize;
    otherwise
        error('Unknown "paddingSets.occPaddingType". Must be "prop" or "square".');
end

% scaleRect
switch paddingSets.scalePaddingType
    case 'prop'
        paddingParams.scaleRectPadding = repmat(paddingSets.scalePaddingValue, [1, 2]);
    otherwise
        error('Unknown "paddingSets.scalePaddingType". Must be "prop".');
end

end