function [imgPaths, gt, frameNum] =loadVideoInfo(videoPath, seqName, beginFrame)
imgFolder = [videoPath '/' seqName];
gtFile = [imgFolder '/groundtruth.txt'];
gt = load(gtFile);
frameNum = size(gt, 1) - beginFrame + 1;
gt = gt(beginFrame : end, :);

switch seqName
    case 'BlurCar1'
        img_files = num2str((247:988)', [imgFolder '/img/' '%04i.jpg']);
    case 'BlurCar3'
        img_files = num2str((3:359)', [imgFolder '/img/' '%04i.jpg']);
    case 'BlurCar4'
        img_files = num2str((18:397)', [imgFolder '/img/' '%04i.jpg']);
    otherwise
        if exist([imgFolder '/' num2str(1, '%08i.png')], 'file'),
            img_files = num2str((beginFrame : beginFrame + frameNum - 1)', [imgFolder '/' '%08i.png']);
        elseif exist([imgFolder '/' num2str(1, '%08i.jpg')], 'file'),
            img_files = num2str((beginFrame : beginFrame + frameNum - 1)', [imgFolder '/' '%08i.jpg']);
        elseif exist([imgFolder '/' num2str(1, '%08i.bmp')], 'file'),
            img_files = num2str((1:frameNum)', [imgFolder '/img/' '%04i.bmp']);
        elseif exist([imgFolder '/' num2str(1, '%08i.jpg')], 'file'),
            img_files = num2str((1:frameNum)', [imgFolder '/img/' '%08i.jpg']);
        else
            error('No image files to load.')
        end
end

imgPaths = cellstr(img_files);

end

