function position = run_tracker(img, frame, rect)

persistent Params MkcfResults
if frame == 1
    Params.lambda1 = 0.0002;
    Params.lambda2 = 0.0001;
    Params.eta = 0.01;
    Params.scaleSensitivity = 0.02;
    Params.outputSigmaFactor = 1 / 10;
    Params.cellSize = 4;
    Params.smallSampleTukeywinR = 0.6;
    Params.gausswinAlpha = 3;
    Params.allLayers = [28, 37];
    Params.winRectLayer = [28, 37];
    
    padding = struct('generic', 2.8, 'large', 2, 'height', 1.4);
    Params.paddingSets = struct('padding', padding,...
                                'smallPaddingValue', 1.5,...
                                'smallPaddingType', 'prop',...  % 'prop' only
                                'occPaddingValue', 3.5, ...
                                'occPaddingType', 'square',...  % 'prop' or 'square'
                                'scalePaddingValue', 2,...
                                'scalePaddingType', 'prop'...
                               );

    Params.visualization = 0;
    Params.scaleDetection = 1;
    Params.occDetection = 0;
    Params.outputIteration = 1;
end

if frame == 1
    MkcfResults = initTracker(img, rect, Params);
else
    MkcfResults = trackFrame(img, MkcfResults, Params, frame);
end

position = MkcfResults.realRect;

end