function bestRect = searchScale(img, srcWinRect, Samples, alpha_f, d, initWinRect, normalizedScaleRectSize, scaleSensitivity, cellSize)

minS = 0.9;  maxS = 1.1;
srcScaleRect = changeRectPadding(srcWinRect, 'winRect', 'scaleRect');
initScaleRect = changeRectPadding(initWinRect, 'winRect', 'scaleRect');
origSize = srcScaleRect(3:4);
center = (srcScaleRect(1:2) + srcScaleRect(1:2) + srcScaleRect(3:4) - 1) / 2;
t = (sqrt(5) - 1) / 2;
left = minS;
right = maxS;
gap = right - left;
% score_left = scalePsr(Samples, alpha_f, center, origSize, normalizedWinRectSize, left);
% score_right = scalePsr(Samples, alpha_f, center, origSize, normalizedWinRectSize, right);

p = left + (1 - t) * gap;
q = left + t * gap;
score_p = scalePsr(img, cellSize, Samples, alpha_f, d, center, origSize, normalizedScaleRectSize, p);
score_q = scalePsr(img, cellSize, Samples, alpha_f, d, center, origSize, normalizedScaleRectSize, q);

delta = max(origSize);
initP = prod(initScaleRect(3:4)) / prod(origSize);
if initP > 1.1
    fix = @(x)0.5 * x + 0.5;
else
    if initP < 0.9
        fix = @(x)-0.5 * x + 1.5;
    else
        fix = @(x)1;
    end
end
% fix = @(x)1;

while (gap * delta(1) > 1)
    if score_p > score_q
        right = q;  score_right = score_q;  q = p;  score_q = score_p;
		gap = right - left;  p = left + (1 - t) * gap;
        score_p = fix(p) * scalePsr(img, cellSize, Samples, alpha_f, d, center, origSize, normalizedScaleRectSize, p);
    else
        left = p;  score_left = score_p;  p = q;  score_p = score_q;
		gap = right - left;  q = left + t * gap;
        score_q = fix(q) * scalePsr(img, cellSize, Samples, alpha_f, d, center, origSize, normalizedScaleRectSize, q);
    end
    if left >= 1 - scaleSensitivity && left <= 1 + scaleSensitivity && right >= 1 - scaleSensitivity && right <= 1 + scaleSensitivity
        score_p = 1;
        score_q = 1;
        break;
    end
end
if score_p >= score_q
    bestScale = p;
else
    bestScale = q;
end
if bestScale >= 1 - scaleSensitivity && bestScale <= 1 + scaleSensitivity
    bestScale = 1;
end
% disp('  ');
% disp(['bestScale: ' num2str(bestScale)]);
% disp('  ');
newWinSize = (srcWinRect(3:4) - 1) * bestScale + 1;
newWinSize = initWinRect(3:4) * sqrt(prod(newWinSize) / prod(initWinRect(3:4)));
bestRect = round([center - ((newWinSize - 1) / 2), newWinSize]);

end
