function d = trainMultiD(ks, alpha, y, lambda1, lambda2, prevD)
kNum = length(ks);
B = zeros(kNum, kNum);
c = zeros(kNum, 1);
ks_f = cell(kNum, 1);
alpha_f = fft2(alpha);
for i = 1:kNum
    ks_f{i} = fft2(ks{i});
end

for m = 1:kNum
    for n = 1:kNum
        kmn_f = (conj(ks_f{n}) .* ks_f{m}) + (conj(ks_f{m}) .* ks_f{n});
        temp = ifft2(conj(kmn_f) .* alpha_f);
        B(m,n) = alpha(:)' * temp(:) + 2 * lambda2;
    end
end

temp = 2 * y - lambda1 * alpha;
for m = 1:kNum
    temp_m = ifft2(conj(ks_f{m}) .* alpha_f);
    c(m) = temp(:)' * temp_m(:) + 2 * lambda2;
end

% d = searchD_NewtonMethod(B, c, prevD);
d = searchD_GradientMethod(ks, alpha_f, y, lambda1, lambda2, B, c, prevD);
end